﻿001 Program FeuxCarrefour;
002 
003 Uses Crt, x86 ;
004 
005 // Definition des variables
006 
007 Var
008 	Finir, ManFinir, ModeAuto : Boolean;
009 	ChoixMenu, CharControl : Char;
010         x, y : LongInt;
011 
012 // Affichage Mode Automatique
013 
014 Procedure AfficheModeAuto;
015 
016 Begin
017         TextColor (LightRed);
018 	Gotoxy (99, 7); Write('MODE AUTOMATIQUE');
019 	Textcolor(Green);
020 	Gotoxy (99, 10); Write('              ');
021 	Gotoxy (99, 12); Write('                  ');
022 	Gotoxy (99, 14); Write('                   ');
023 	Gotoxy (99, 16); Write('          ');
024 	TextColor (Yellow);
025         Gotoxy (92, 20); Write ('Appuyez ESC pour quitter le Mode');
026         Gotoxy (48, 47);
027 End;
028 
029 // Affichage Mode Manuel cyclique
030 
031 Procedure AfficheModeManuelCycl;
032 
033 Begin
034         TextColor (LightRed);
035 	Gotoxy (96, 7); Write('MODE MANUEL CYCLIQUE');
036 	Textcolor(Green);
037 	Gotoxy (99, 10); Write('              ');
038 	Gotoxy (99, 12); Write('                  ');
039 	Gotoxy (99, 14); Write('                   ');
040 	Gotoxy (99, 16); Write('          ');
041 	TextColor (Yellow);
042         Gotoxy (91, 20); Write ('Appuyez ESC pour quitter le Mode');
043         Gotoxy (91, 24); Write ('Tapez ESPACE pour changer Etats');
044         Gotoxy (48, 47);
045 End;
046 
047 // Affichage Mode Manuel Aleatoire
048 
049 Procedure AfficheModeManuelAlea;
050 
051 Begin
052         TextColor (LightRed);
053 	Gotoxy (96, 7); Write('MODE MANUEL ALEATOIRE');
054 	Textcolor(Green);
055 	Gotoxy (99, 10); Write('1. Etat 01    ');
056 	Gotoxy (99, 12); Write('2. Etat 02        ');
057 	Gotoxy (99, 14); Write('3. Etat 03         ');
058 	Gotoxy (99, 16); Write('4. Etat 04');
059         Gotoxy (99, 18); Write('5. Quitter le Mode');
060 	TextColor (Yellow);
061         Gotoxy (92, 20); Write ('Faites un Choix avec une Touche');
062         Gotoxy (48, 47);
063 End;
064 
065 
066 // Routine pour afficher le menu principal
067 
068 Procedure AfficheMenuPrin;
069 
070 Begin
071 	TextColor (LightRed);
072 	Gotoxy (100, 7); Write('MENU PRINCIPAL');
073 	Textcolor(Green);
074 	Gotoxy (99, 10); Write('1. Automatique');
075 	Gotoxy (99, 12); Write('2. Manuel Cyclique');
076 	Gotoxy (99, 14); Write('3. Manuel Aleatoire');
077 	Gotoxy (99, 16); Write('4. Quitter');
078 	TextColor (Yellow);
079         Gotoxy (92, 20); Write ('Faites un Choix avec une Touche');
080         Gotoxy (48, 47);
081 End;
082 
083 
084 // Routine pour afficher la fenetre principale
085 
086 Procedure AfficheEcranPrin;
087 
088 Begin
089 
090         // Tracage Presentation Ecran
091         ClrScr;
092         TextColor (Blue);
093         For x:= 5 to 124 do
094                 Begin
095                         Gotoxy (x, 46); Write(Chr(205));
096                         Gotoxy (x, 3); Write(Chr(205));
097                 End;
098         For y:= 4 to (45) do
099                 Begin
100                         Gotoxy (4, y); Write(Chr(186));
101                         Gotoxy (125, y); Write(Chr(186));
102                         Gotoxy (88, y); Write(Chr(186));
103                 End;
104         Gotoxy (4, 3); Write (Chr(201));
105         Gotoxy (125, 3); Write (Chr(187));
106         Gotoxy (4, 46); Write (Chr(200));
107         Gotoxy (125, 46);Write (Chr(188));
108         Gotoxy (88, 3); Write (Chr(203));
109         Gotoxy (88, 46); Write (Chr(202));
110 
111         // Affichage Points Cardinaux
112         TextColor (Yellow);
113         Gotoxy (42, 4); Write ('NORD');
114         Gotoxy (43, 45); Write ('SUD');
115         Gotoxy (6, 24); Write ('OUEST');
116         Gotoxy (84, 24); Write ('EST');
117 
118         // Affichage Copyright
119         TextColor (LightRed);
120         Gotoxy (92, 43); Write ('Copyright NGOY - YINDULA 2006');
121         Gotoxy (96, 44); Write ('Tous droits reserves');
122 
123         // Tracage route EST - OUEST
124         TextColor (LightGray);
125         For x:= 5 to 87 do
126                 Begin
127                         Gotoxy (x, 21); Write(Chr(196));
128                         Gotoxy (x, 27); Write(Chr(196));
129                 End;
130         For x:= 37 to 50 do
131                 Begin
132                         Gotoxy (x, 21); Write(Chr(32));
133                         Gotoxy (x, 27); Write(Chr(32));
134                 End;
135         Gotoxy (13, 24); Write(Chr(223) + Chr(223) + Chr(223) + Chr(223));
136         Gotoxy (22, 24); Write(Chr(223) + Chr(223) + Chr(223) + Chr(223));
137         Gotoxy (31, 24); Write(Chr(223) + Chr(223) + Chr(223) + Chr(223));
138         Gotoxy (40, 24); Write(Chr(223) + Chr(223) + Chr(223));
139         Gotoxy (46, 24); Write(Chr(223) + Chr(223) + Chr(223));
140         Gotoxy (53, 24); Write(Chr(223) + Chr(223) + Chr(223) + Chr(223));
141         Gotoxy (62, 24); Write(Chr(223) + Chr(223) + Chr(223) + Chr(223));
142         Gotoxy (71, 24); Write(Chr(223) + Chr(223) + Chr(223) + Chr(223));
143         Gotoxy (79, 24); Write(Chr(223) + Chr(223) + Chr(223) + Chr(223));
144 
145         // Tracage route NORD - SUD
146         For y:= 4 to 45 do
147                 Begin
148                         Gotoxy (37, y); Write (Chr(179));
149                         Gotoxy (51, y); Write (Chr(179));
150                 End;
151         For y:= 21 to 27 do
152                 Begin
153                         Gotoxy (37, y); Write(Chr(32));
154                         Gotoxy (51, y); Write(Chr(32));
155                 End;
156         Gotoxy (44, 6); Write (Chr(219));
157         Gotoxy (44, 7); Write (Chr(219));
158         Gotoxy (44, 11); Write (Chr(219));
159         Gotoxy (44, 12); Write (Chr(219));
160         Gotoxy (44, 16); Write (Chr(219));
161         Gotoxy (44, 17); Write (Chr(219));
162         Gotoxy (44, 21); Write (Chr(219));
163         Gotoxy (44, 22); Write (Chr(219));
164         Gotoxy (44, 26); Write (Chr(219));
165         Gotoxy (44, 27); Write (Chr(219));
166         Gotoxy (44, 31); Write (Chr(219));
167         Gotoxy (44, 32); Write (Chr(219));
168         Gotoxy (44, 36); Write (Chr(219));
169         Gotoxy (44, 37); Write (Chr(219));
170         Gotoxy (44, 41); Write (Chr(219));
171         Gotoxy (44, 42); Write (Chr(219));
172 
173         // Tracage Carrefour
174         Gotoxy (37,21); Write (Chr(217));
175         Gotoxy (37,27); Write (Chr(191));
176         Gotoxy (51,21); Write (Chr(192));
177         Gotoxy (51,27); Write (Chr(218));
178 
179         // Affichage LED eteintes NORD RJV
180         Gotoxy (35, 19); Write (Chr(220));
181         Gotoxy (35, 18); Write (Chr(220));
182         Gotoxy (35, 17); Write (Chr(220));
183 
184         // Affichage LED eteintes SUD RJV
185         Gotoxy (53, 28); Write (Chr(220));
186         Gotoxy (53, 29); Write (Chr(220));
187         Gotoxy (53, 30); Write (Chr(220));
188 
189         // Affichage LED eteintes EST RJV
190         Gotoxy (54, 20); Write (Chr(220));
191         Gotoxy (56, 20); Write (Chr(220));
192         Gotoxy (58, 20); Write (Chr(220));
193 
194         // Affichage LED eteintes OUEST RJV
195         Gotoxy (34, 28); Write (Chr(220));
196         Gotoxy (32, 28); Write (Chr(220));
197         Gotoxy (30, 28); Write (Chr(220));
198         Gotoxy (48, 47);
199 End;
200 
201 // Affichage Etape 1
202 
203 Procedure AfficheEtat01;
204 
205 Begin
206         TextColor (LightRed);
207         Gotoxy (35, 19); Write (Chr(220));
208         Gotoxy (53, 28); Write (Chr(220));
209         TextColor (LightGreen);
210         Gotoxy (30, 28); Write (Chr(220));
211         Gotoxy (58, 20); Write (Chr(220));
212         TextColor (LightGray);
213         Gotoxy (35, 18); Write (Chr(220));
214         Gotoxy (53, 29); Write (Chr(220));
215         Gotoxy (35, 17); Write (Chr(220));
216         Gotoxy (53, 30); Write (Chr(220));
217         Gotoxy (34, 28); Write (Chr(220));
218         Gotoxy (54, 20); Write (Chr(220));
219         Gotoxy (32, 28); Write (Chr(220));
220         Gotoxy (56, 20); Write (Chr(220));
221         Gotoxy (48, 47);
222 End;
223 
224 // Affichage Etape 2
225 
226 Procedure AfficheEtat02;
227 
228 Begin
229         TextColor (LightRed);
230         Gotoxy (35, 19); Write (Chr(220));
231         Gotoxy (53, 28); Write (Chr(220));
232         TextColor (Yellow);
233         Gotoxy (32, 28); Write (Chr(220));
234         Gotoxy (56, 20); Write (Chr(220));
235         TextColor (LightGray);
236         Gotoxy (35, 18); Write (Chr(220));
237         Gotoxy (53, 29); Write (Chr(220));
238         Gotoxy (35, 17); Write (Chr(220));
239         Gotoxy (53, 30); Write (Chr(220));
240         Gotoxy (34, 28); Write (Chr(220));
241         Gotoxy (54, 20); Write (Chr(220));
242         Gotoxy (30, 28); Write (Chr(220));
243         Gotoxy (58, 20); Write (Chr(220));
244         Gotoxy (48, 47);
245 End;
246 
247 // Affichage Etape 3
248 
249 Procedure AfficheEtat03;
250 
251 Begin
252         TextColor (LightRed);
253         Gotoxy (34, 28); Write (Chr(220));
254         Gotoxy (54, 20); Write (Chr(220));
255         TextColor (LightGreen);
256         Gotoxy (35, 17); Write (Chr(220));
257         Gotoxy (53, 30); Write (Chr(220));
258         TextColor (LightGray);
259         Gotoxy (35, 19); Write (Chr(220));
260         Gotoxy (53, 28); Write (Chr(220));
261         Gotoxy (35, 18); Write (Chr(220));
262         Gotoxy (53, 29); Write (Chr(220));
263         Gotoxy (32, 28); Write (Chr(220));
264         Gotoxy (56, 20); Write (Chr(220));
265         Gotoxy (30, 28); Write (Chr(220));
266         Gotoxy (58, 20); Write (Chr(220));
267         Gotoxy (48, 47);
268 End;
269 
270 // Affichage Etape 4
271 
272 Procedure AfficheEtat04;
273 
274 Begin
275         TextColor (LightRed);
276         Gotoxy (34, 28); Write (Chr(220));
277         Gotoxy (54, 20); Write (Chr(220));
278         TextColor (Yellow);
279         Gotoxy (35, 18); Write (Chr(220));
280         Gotoxy (53, 29); Write (Chr(220));
281         TextColor (LightGray);
282         Gotoxy (35, 19); Write (Chr(220));
283         Gotoxy (53, 28); Write (Chr(220));
284         Gotoxy (35, 17); Write (Chr(220));
285         Gotoxy (53, 30); Write (Chr(220));
286         Gotoxy (32, 28); Write (Chr(220));
287         Gotoxy (56, 20); Write (Chr(220));
288         Gotoxy (30, 28); Write (Chr(220));
289         Gotoxy (58, 20); Write (Chr(220));
290         Gotoxy (48, 47);
291 End;
292 
293 // Routine pour Premiere Etape du cycle
294 
295 Procedure Etat01;
296 Begin
297 	WritePortB($378,33);
298         AfficheEtat01;
299 	If ModeAuto then Delay (7000);
300 End;
301 
302 // Routine pour Seconde Etape du cycle
303 
304 Procedure Etat02;
305 Begin
306 	WritePortB($378,34);
307         AfficheEtat02;
308 	If ModeAuto then Delay (3000);
309 End;
310 
311 // Routine pour Troisieme Etape du cycle
312 
313 Procedure Etat03;
314 Begin
315 	WritePortB($378,12);
316         AfficheEtat03;
317 	If ModeAuto then Delay (10000);
318 End;
319 
320 // Routine pour Quatrieme Etape du cycle
321 
322 Procedure Etat04;
323 Begin
324 	WritePortB($378,20);
325         AfficheEtat04;
326 	If ModeAuto then Delay (3000);
327 End;
328 
329 // Routine d'Allumage Manuel Aleatoire
330 
331 Procedure ManuelAlea;
332 
333 Begin
334 	ChoixMenu:= '0';
335 	ModeAuto:= FALSE;
336         AfficheModeManuelAlea;
337 	Repeat
338                 ChoixMenu:= ReadKey;
339 		Case ChoixMenu of
340 			'1': Begin
341 				Etat01;
342 				end;
343 			'2': Begin
344 				Etat02;
345 				end;
346 			'3': Begin
347 				Etat03;
348 				end;
349 			'4': Begin
350 				Etat04;
351 				end;
352 		end;
353 	Until ChoixMenu = '5';
354         WritePortB($378,0);
355 End;
356 
357 // Routine d'Allumage Manuel Cyclique
358 
359 Procedure ManuelCycl;
360 
361 Begin
362         AfficheModeManuelCycl;
363 	Finir := FALSE;
364 	ManFinir:= FALSE;
365 	ModeAuto:= FALSE;
366 
367 	Repeat
368 		Finir := FALSE;
369 		Repeat
370 			Etat01;
371 			CharControl:= ReadKey;
372 			If CharControl = Chr(27) then Begin
373 				WritePortB($378,0);
374 				exit;
375 			End;
376 			If CharControl = Chr(32) then Finir := TRUE;
377 		Until Finir;
378 
379 		Finir := FALSE;
380 
381 		Repeat
382 			Etat02;
383 			CharControl:= ReadKey;
384 			If CharControl = Chr(27) then Begin
385 				WritePortB($378,0);
386 				exit;
387 			End;
388 			If CharControl = Chr(32) then Finir := TRUE;
389 		Until Finir;
390 
391 		Finir := FALSE;
392 
393 		Repeat
394 			Etat03;
395 			CharControl:= ReadKey;
396 			If CharControl = Chr(27) then Begin
397 				WritePortB($378,0);
398 				exit;
399 			End;
400 			If CharControl = Chr(32) then Finir := TRUE;
401 		Until Finir;
402 
403 		Finir := FALSE;
404 
405 		Repeat
406 			Etat04;
407 			CharControl:= ReadKey;
408 			If CharControl = Chr(27) then Begin
409 				WritePortB($378,0);
410 				exit;
411 				End;
412 			If CharControl = Chr(32) then Finir := TRUE;
413 		Until Finir;
414 
415 	Until ManFinir;
416 
417 End;
418 
419 // Routine d'Allumage Automatique
420 
421 Procedure Automatique;
422 
423 Begin
424         AfficheModeAuto;
425 	Finir := FALSE;
426 	ModeAuto:= TRUE;
427 
428 	Repeat
429 		Etat01;
430 		If (KeyPressed and (ReadKey = chr(27))) then Begin
431 			WritePortB($378,0);
432 			exit;
433 		End;
434 
435 		Etat02;
436 		If (KeyPressed and (ReadKey = chr(27))) then Begin
437 			WritePortB($378,0);
438 			exit;
439 		End;
440 
441 		Etat03;
442 		If (KeyPressed and (ReadKey = chr(27))) then Begin
443 			WritePortB($378,0);
444 			exit;
445 		End;
446 
447 		Etat04;
448 		If (KeyPressed and (ReadKey = Chr(27))) then Begin
449 			WritePortB($378,0);
450 			exit;
451 		End;
452 	Until Finir;
453 End;
454 
455 
456 // Debut du Programme Principal
457 
458 Begin
459 	ChoixMenu:= '0';
460 	fpIOperm($378,1,1);
461 	Repeat
462 		Clrscr;
463                 AfficheEcranPrin;
464                 AfficheMenuPrin;
465                 ChoixMenu:= ReadKey;
466 		Case ChoixMenu of
467 			'1': Begin
468 				Automatique;
469 				end;
470 			'2': Begin
471 				ManuelCycl;
472 				end;
473 			'3': Begin
474 				ManuelAlea;
475 				end;
476 		end;
477 	Until ChoixMenu = '4';
478 ClrScr;
479 End.
480 // Fin du programme principal
